<script setup>
import { ref } from "vue";
import { RouterLink } from "vue-router";
import router from "../router";
import { useFetch } from "@vueuse/core";
import { supabase } from "@/supabase";

const imageFile = ref(null)

const formData = ref({
  email: 'akhmad@gmail.com',
  username: 'akhfih',
  password: '1234',
  name: 'akhmad',
  image_url: 'null',
  gender: 'male',
  birthplace: 'kedawon',
  birthdate: '',
  about: 'kasldjfa',
  address: 'lksdfjalks',
  phone: '213145',
  facebook_url: 'akdfh',
  instagram_url: 'akjdfakl',

});

const { isFetching, data, execute: addNewUser } = useFetch(`${import.meta.env.VITE_API_URL}/users`, { immediate: false }).post(formData.value, 'json').json()

const handleFileChange = (event) => {
  if (event.target.files.length === 0) return;

  imageFile.value = event.target.files[0]
}

const handleSubmit = async () => {
  isFetching.value = true;

  const { data } = await supabase.storage
    .from('koncoo')
    .upload(`${Date.now()}-${imageFile.value?.name}`, imageFile.value);

  const { data: { publicUrl } } = await supabase.storage.from('koncoo').getPublicUrl(data.path)

  formData.value.image_url = publicUrl

  console.log(formData)

  await addNewUser()

  router.push('/login')
}

</script>

<template>
  <div class="relative">
    <img class="background absolute -right-60 top-10 -z-2" src="patric.png" alt="" />
    <div class="card">
      <div class="">
        <img class="mb-2 mx-auto" src="logo.png" alt="" />
        <p class="text-center text-2xl">Registration</p>
      </div>
      <form @submit.prevent="handleSubmit" >
      <div class="mb-3">
        <label for="emailInput" class="form-label">Email address</label>
        <input v-model="formData['email']" type="email" class="form-control" id="emailInput" placeholder="email" />
      </div>
      <div class="mb-3">
        <label for="usernameInput" class="form-label">Username</label>
        <input v-model="formData['username']" type="text" class="form-control" id="usernameInput"
          placeholder="username" />
      </div>
      <div class="mb-3">
        <label for="PasswordInput" class="form-label">Password</label>
        <input v-model="formData['password']" type="password" class="form-control" id="PasswordInput"
          placeholder="Password" />
      </div>
      <div class="mb-3">
        <label for="nameInput" class="form-label">Name</label>
        <input v-model="formData['name']" type="text" class="form-control" id="nameInput" placeholder="Name" />
      </div>
      <div class="mb-3">
        <label for="exampleFormControlInput1" class="form-label">Gender</label>
        <select v-model="formData['gender']" class="form-select" aria-label="Default select example">
          <option value="Male">Male</option>
          <option value="Female">Female</option>
        </select>
      </div>
      <div class="mb-3">
        <label for="exampleFormControlInput1" class="form-label">Photo Profile</label>
        <input @change="handleFileChange" class="form-control" type="file" id="formFile" />
      </div>
      <div class="mb-3">
        <label for="birthPlaceInput" class="form-label">Birth Place</label>
        <input v-model="formData['birthplace']" type="text" class="form-control" id="birthPlaceInput"
          placeholder="Birth Place" />
      </div>
      <div class="mb-3">
        <label for="exampleFormControlInput1" class="form-label">Birth Date</label>
        <input v-model="formData['birthdate']" type="date" class="form-control" id="exampleFormControlInput1"
          placeholder="Birth Place" />
      </div>
      <div class="mb-3">
        <label for="exampleFormControlInput1" class="form-label">About</label>
        <textarea v-model="formData['about']" class="form-control" placeholder="About" id="floatingTextarea2"
          style="height: 100px"></textarea>
      </div>
      <div class="mb-3">
        <label for="exampleFormControlInput1" class="form-label">Address</label>
        <textarea v-model="formData['address']" class="form-control" placeholder="Address" id="floatingTextarea2"
          style="height: 100px"></textarea>
      </div>

      <div class="mb-3">
        <label for="exampleFormControlInput1" class="form-label">phone</label>
        <input v-model="formData['phone']" type="text" class="form-control" id="phoneInput" placeholder="Phone" />
      </div>
      <div class="mb-3">
        <label for="exampleFormControlInput1" class="form-label">Facebook</label>
        <input v-model="formData['facebook_url']" type="text" class="form-control" id="exampleFormControlInput1"
          placeholder="Facebook" />
      </div>
      <div class="mb-3">
        <label for="exampleFormControlInput1" class="form-label">Instagram</label>
        <input v-model="formData['instagram_url']" type="text" class="form-control" id="exampleFormControlInput1"
          placeholder="Instagram" />
      </div>
      <div>
        <button class="btn btn-primary" type="submit" :disabled="isFetching">Sign Up</button>
        <!-- <button type="button" class="btn btn-outline-primary mt-3">Log In</button> -->
      </div>
    </form>


    </div>
  </div>
</template>

<style lang="postcss" scoped>
.background {
  width: 1000px;
  margin-bottom: 2500px
}

.card {
  @apply absolute;

  padding: 24px;
  width: 500px;
  margin-top: 100px;
  margin-bottom: 100px;
  left: 10vw;
}

.relative {
  padding-bottom: 1700px;
}
</style>
